if pikachu == nil then pikachu = {} end
pikachu.time = {}

time_online = true

-- Settings

-- Colour table
colourtable = {
	{
		name = "Red",
		red = 255,
		green = 0,
		blue = 0,
	},
	{
		name = "Green",
		red = 0,
		green = 255,
		blue = 0,
	},
	{
		name = "Blue",
		red = 0,
		green = 0,
		blue = 255,
	},
	{
		name = "Yellow",
		red = 255,
		green = 255,
		blue = 0,
	},
	{
		name = "Cyan",
		red = 0,
		green = 255,
		blue = 255,
	},
	{
		name = "Magenta Pink",
		red = 255,
		green = 0,
		blue = 255,
	},
	{
		name = "Azure Blue",
		red = 0,
		green = 128,
		blue = 255,
	},
	{
		name = "Chartreuse Green",
		red = 128,
		green = 255,
		blue = 0,
	},
	{
		name = "Orange",
		red = 255,
		green = 128,
		blue = 0,
	},
	{
		name = "Violet Purple",
		red = 128,
		green = 0,
		blue = 255,
	},
	{
		name = "Rose Pink",
		red = 255,
		green = 0,
		blue = 128,
	},
	{
		name = "Electric Purple",
		red = 192,
		green = 0,
		blue = 255,
	},
	{
		name = "Lime Green",
		red = 192,
		green = 255,
		blue = 0,
	},
	{
		name = "Sky Blue",
		red = 0,
		green = 192,
		blue = 255,
	},
	{
		name = "Celeste Blue",
		red = 128,
		green = 255,
		blue = 255,
	},
	{
		name = "Baby Blue",
		red = 128,
		green = 192,
		blue = 255,
	},
	{
		name = "Lavender Purple",
		red = 192,
		green = 128,
		blue = 255,
	},
	{
		name = "Persian Pink",
		red = 255,
		green = 128,
		blue = 192,
	},
	{
		name = "Ultra Pink",
		red = 255,
		green = 128,
		blue = 255,
	},
	{
		name = "White",
		red = 255,
		green = 255,
		blue = 255,
	},
	{
		name = "Black",
		red = 0,
		green = 0,
		blue = 0,
	},
	{
		name = "Spectator Yellow",
		red = 255,
		green = 220,
		blue = 0,
	},
	{
		name = "T Red",
		red = 255,
		green = 25,
		blue = 0,
	},
	{
		name = "CT Blue",
		red = 50,
		green = 150,
		blue = 255,
	},
}

-- Position table
postable = {
	--[[
	{
		name = "Top Left",
		x = 8,
		y = 112,
		orientation = 0,
	},
	]]
	{
		name = "Top Right",
		x = 636,
		y = 112,
		orientation = 2,
	},
	{
		name = "Bottom Right",
		x = 636,
		y = 328,
		orientation = 2,
	},
}

-- Style table
styletable = {
	-- Time
	["time"] = {
		{
			name = "12 hour clock",
			syntax = "%I:%M:%S %p"
		},
		{
			name = "24 hour clock",
			syntax = "%H:%M:%S"
		},
	},
	-- Date
	["date"] = {
		{
			name = "Full date+Day",
			syntax = "%A, %d %B %Y"
		},
		{
			name = "Abbr. date+Day",
			syntax = "%A, %d %b %y"
		},
		{
			name = "Full date+day",
			syntax = "%a, %d %B %Y"
		},
		{
			name = "Abbr. date+day",
			syntax = "%a, %d %b %y"
		},
		{
			name = "Full date",
			syntax = "%d %B %Y"
		},
		{
			name = "Abbreviated date",
			syntax = "%d %b %y"
		},
		{
			name = "Day + d/m/yy",
			syntax = "%A, %d/%m/%y"
		},
		{
			name = "day + d/m/yy",
			syntax = "%a, %d/%m/%y"
		},
		{
			name = "d/m/yy",
			syntax = "%d/%m/%y"
		},
		{
			name = "Day + m/d/yy",
			syntax = "%A, %m/%d/%y"
		},
		{
			name = "day + m/d/yy",
			syntax = "%a, %m/%d/%y"
		},
		{
			name = "m/d/yy",
			syntax = "%m/%d/%y"
		},
		{
			name = "Day + d/m/4y",
			syntax = "%A, %d/%m/%Y"
		},
		{
			name = "day + d/m/4y",
			syntax = "%a, %d/%m/%Y"
		},
		{
			name = "d/m/4y",
			syntax = "%d/%m/%Y"
		},
		{
			name = "Day + m/d/4y",
			syntax = "%A, %m/%d/%Y"
		},
		{
			name = "day + m/d/4y",
			syntax = "%a, %m/%d/%Y"
		},
		{
			name = "m/d/4y",
			syntax = "%m/%d/%Y"
		},
	}
}

-- Defaults
default = {
	colour = "Yellow",
	state = false,
	pos = "Bottom Right",
	styletime = 1,
	styledate = 1,
	customcolour = false,
}

servertimezone = 8

time_optimize = true

-- End of Settings

function digits(n,p,m)
	if not m then
		m = 10^p - 1
	end
	if n == 0 then
		local z = ""
		for a = 1, p do
			z = z.."0"
		end
		return z
	end
	if n <= m then
		local _p = 0
		while (n < 10^(p-1)) do
			p = p-1
			_p = _p + 1
		end
		local str = n
		for i = 1, _p, 1 do
			str = "0"..str
		end
		return str
	else
		return m
	end
end

function addcolour(n,r,g,b)
	if type(n) == "string" and n ~= "" then
		if r == nil then r = 0 end
		if g == nil then g = 0 end
		if b == nil then b = 0 end
		table.insert(colourtable,{name = n, num = string.format("%s%s%s",digits(r,3,255),digits(g,3,255),digits(b,3,255))})
	end
end

function addpos(n,xpos,xpos,o)
	if type(n) == "string" and n ~= "" and xpos and ypos and o then
		table.insert(postable,{name = n, x = xpos, y = ypos, orientation = o})
	end
end

-- Time Zone table, don't touch!
timezones = {-12,-11,-10,-9,-8,-7,-6,-5,-4,-4.5,-3,-3.5,-2,-1,0,1,2,3,3.5,4,4.5,5,5.5,6,6.5,7,8,8.5,9,9.5,10,11,12,13,14}
loadtime = false

for j1, j2 in ipairs(timezones) do
	if servertimezone == j2 then
		default.timezone = j1
		loadtime = true
		break
	end
end

if not loadtime then
	default.timezone = 27
end

for k = 1, #colourtable do
	if colourtable[k].red == nil then colourtable[k].red = 0 end
	if colourtable[k].green == nil then colourtable[k].green = 0 end
	if colourtable[k].blue == nil then colourtable[k].blue = 0 end
	colourtable[k].num = string.format("%s%s%s",digits(colourtable[k].red,3,255),digits(colourtable[k].green,3,255),digits(colourtable[k].blue,3,255))
end

for l = 1, #postable do
	if postable[l].x == nil then postable[l].x = 0 end
	if postable[l].y == nil then postable[l].y = 0 end
	if postable[l].orientation == nil then
		postable[l].orientation = 0
	elseif postable[l].orientation < 0 then
		postable[l].orientation = 0
	elseif postable[l].orientation > 2 then
		postable[l].orientation = 2
	end
end

for m = 1, #styletable.date do
	styletable.date[m].desc = string.gsub(styletable.date[m].syntax,",+","")
end

if type(default.colour) == "string" then
	local valid = false
	for m = 1, #colourtable do
		if default.colour == colourtable[m].name then
			default.colour = m
			valid = true
			break
		end
	end
	if not valid then
		default.colour = 1
	end
end

if type(default.pos) == "string" then
	local valid = false
	for n = 1, #postable do
		if default.pos == postable[n].name then
			default.pos = n
			valid = true
			break
		end
	end
	if not valid then
		default.pos = 1
	end
end

if type(default.styletime) == "string" then
	local valid = false
	for o = 1, #styletable.time do
		if default.styletime ==  styletable.time[o].name then
			default.styletime = o
			valid = true
			break
		end
	end
	if not valid then
		default.pos = 1
	end
end

if type(default.styledate) == "string" then
	local valid = false
	for p = 1, #styletable.date do
		if default.styledate == styletable.date[p].name then
			default.styledate = p
			valid = true
			break
		end
	end
	if not valid then
		default.pos = 1
	end
end

coloursel = {}
colouron = {}
possel = {}
styletimesel = {}
styledatesel = {}
timezonesel = {}
customcoloursel = {}

function colourmenu(id,page)
	local pages = math.ceil(#colourtable/6)
	local c = "Time Display Colour Page "..page
	local p = 6 * page
	for a = p-5, p do
		if colourtable[a] then
			if colourtable[a].name then
				if a ~= coloursel[id] or customcoloursel[id].enabled then
					c = c..","..colourtable[a].name.." |\169"..colourtable[a].num
				else
					c = c..",("..colourtable[a].name.." |\169"..colourtable[a].num
				end
			else
				c = c..","
			end
		else
			c = c..","
		end
	end
	if page == 1 then
		c = c..",,Custom Colour |"..colourcheck(id,"custom")
	else
		c = c..",,Back |Page "..page-1
	end
	if page == pages then
		c = c..",Custom Colour |"..colourcheck(id,"custom")
	else
		c = c..",Next |Page "..page+1
	end
	menu(id,c)
end

function posmenu(id,page)
	local pages = math.ceil(#postable/6)
	local c = "Time Display Position Page "..page
	local p = 6 * page
	for b = p-5, p do
		if postable[b] then
			if postable[b].name then
				if b ~= possel[id] then
					c = c..","..postable[b].name.." |["..postable[b].x.." | "..postable[b].y.."] "..orientationsetting(b)
				else
					c = c..",("..postable[b].name.." |["..postable[b].x.." | "..postable[b].y.."] "..orientationsetting(b)
				end
			else
				c = c..","
			end
		else
			c = c..","
		end
	end
	if page == 1 then
		c = c..",,Toggle Display |"..colourcheck(id)
	else
		c = c..",,Back |Page "..page-1
	end
	if page == pages then
		c = c..",Toggle Display |"..colourcheck(id)
	else
		c = c..",Next |Page "..page+1
	end
	menu(id,c)
end

function timezoneformat(f)
	local t
	local remainder = timezones[f] % 1
	local quotient = timezones[f] - remainder
	if timezones[f] >= 0 then
		if timezones[f] < 10 then
			t = "UTC+0"..quotient
		else
			t = "UTC+"..quotient
		end
	else
		if timezones[f] > -10 then
			t = "UTC-0"..math.abs(quotient)
		else
			t = "UTC"..quotient
		end
	end
	if remainder == 0.5 then
		t = t..":30"
	elseif remainder == 0 then
		t = t..":00"
	end
	return t
end

function stylemenu(id,mode,page)
	local pages
	local p = 6 * page
	local c
	if mode == "time" then
		pages = math.ceil(#styletable.time/6)
		c = "Time Display Time Style Page "..page
		for d = p-5, p do
			if styletable.time[d] then
				if (styletable.time[d].name and styletable.time[d].syntax) then
					if d ~= styletimesel[id] then
						c = c..","..styletable.time[d].name.." |"..styletable.time[d].syntax
					else
						c = c..",("..styletable.time[d].name.." |"..styletable.time[d].syntax
					end
				else
					c = c..","
				end
			else
				c = c..","
			end
		end
	elseif mode == "date" then
		pages = math.ceil(#styletable.date/6)
		c = "Time Display Date Style Page "..page
		for e = p-5, p do
			if styletable.date[e] then
				if (styletable.date[e].name and styletable.date[e].syntax) then
					if e ~= styledatesel[id] then
						c = c..","..styletable.date[e].name.." |"..styletable.date[e].desc
					else
						c = c..",("..styletable.date[e].name.." |"..styletable.date[e].desc
					end
				else
					c = c..","
				end
			else
				c = c..","
			end
		end
	end
	if page == 1 then
		c = c..",,Toggle Display |"..colourcheck(id)
	else
		c = c..",,Back |Page "..page-1
	end
	if page == pages then
		c = c..",Toggle Display |"..colourcheck(id)
	else
		c = c..",Next |Page "..page+1
	end
	menu(id,c)
end

function timezonemenu(id,page)
	local pages = math.ceil(#timezones/6)
	local c = "Time Display Time Zone Page "..page
	local p = 6 * page
	for f = p-5, p do
		if timezones[f] then
			if f ~= timezonesel[id] then
				c = c..","..timezoneformat(f)
			else
				c = c..",("..timezoneformat(f)
			end
			if timezones[f] == servertimezone then
				c = c.." |Server"
			end
		else
			c = c..","
		end
	end
	if page == 1 then
		c = c..",,Toggle Display |"..colourcheck(id)
	else
		c = c..",,Back |Page "..page-1
	end
	if page == pages then
		c = c..",Toggle Display |"..colourcheck(id)
	else
		c = c..",Next |Page "..page+1
	end
	menu(id,c)
end

function orientationsetting(s)
	if postable[s].orientation == 0 then
		return "<"
	elseif postable[s].orientation == 1 then
		return "o"
	else
		return ">"
	end
end

function colourcheck(id,custom)
	if custom == "custom" then
		if customcoloursel[id].enabled == true then
			return "Enabled"
		end
	else
		if colouron[id] == true then
			return "Enabled"
		end
	end
	return "Disabled"
end

function customcolourmenu(id,mode)
	if mode == "show" then
		customcoloursel[id].menu1i1 = image("gfx/yates/lua/shit_colour_menu_2.png",320,240,2,id)
		customcoloursel[id].menu1i2 = image("gfx/yates/lua/shit_colour_menu_example.png",320,240,2,id)
		customcoloursel[id].menu1i3 = image("gfx/yates/lua/shit_colour_menu_arrow.png",192+customcoloursel[id].r,230,2,id)
		customcoloursel[id].menu1i4 = image("gfx/yates/lua/shit_colour_menu_arrow.png",192+customcoloursel[id].g,258,2,id)
		customcoloursel[id].menu1i5 = image("gfx/yates/lua/shit_colour_menu_arrow.png",192+customcoloursel[id].b,286,2,id)
		customcoloursel[id].inmenu = true
		msg2(id,"\169000255000Use your mouse and click to set your custom colour!")
		updatecustomcolour(id)
	elseif mode == "hide" then
		freeimage(customcoloursel[id].menu1i1)
		freeimage(customcoloursel[id].menu1i2)
		freeimage(customcoloursel[id].menu1i3)
		freeimage(customcoloursel[id].menu1i4)
		freeimage(customcoloursel[id].menu1i5)
		customcoloursel[id].menu1i1 = nil
		customcoloursel[id].menu1i2 = nil
		customcoloursel[id].menu1i3 = nil
		customcoloursel[id].menu1i4 = nil
		customcoloursel[id].menu1i5 = nil
		customcoloursel[id].inmenu = false
		parse('hudtxt2 '..id..' 37 "" 255 156')
		parse('hudtxt2 '..id..' 38 "" 255 171')
		parse('hudtxt2 '..id..' 39 "" 255 186')
	end
end

function updatecustomcolour(id)
	if customcoloursel[id].inmenu then
		local r, g, b = customcoloursel[id].r, customcoloursel[id].g, customcoloursel[id].b
		imagecolor(customcoloursel[id].menu1i2,r,g,b)
		imagepos(customcoloursel[id].menu1i3,192+r,230,0)
		imagepos(customcoloursel[id].menu1i4,192+g,258,0)
		imagepos(customcoloursel[id].menu1i5,192+b,286,0)
		parse('hudtxt2 '..id..' 37 "\169255000000R:\169255255255 '..r..'" 255 156')
		parse('hudtxt2 '..id..' 38 "\169000255000G:\169255255255 '..g..'" 255 171')
		parse('hudtxt2 '..id..' 39 "\169000000255B:\169255255255 '..b..'" 255 186')
	end
end

-- Primary functions

addhook("join","pikachu.time.join")
function pikachu.time.join(id)
	coloursel[id] = default.colour
	colouron[id] = default.state
	possel[id] = default.pos
	styletimesel[id] = default.styletime
	styledatesel[id] = default.styledate
	timezonesel[id] = default.timezone
	customcoloursel[id] = {}
	customcoloursel[id].enabled = default.customcolour
	customcoloursel[id].inmenu = false
	customcoloursel[id].r = 255
	customcoloursel[id].g = 255
	customcoloursel[id].b = 255
end

addhook("leave","pikachu.time.leave")
function pikachu.time.leave(id)
	coloursel[id] = nil
	colouron[id] = nil
	possel[id] = nil
	styletimesel[id] = nil
	styledatesel[id] = nil
	timezonesel[id] = nil
	customcoloursel[id] = nil
end

addhook("serveraction","pikachu.time.serveraction")
function pikachu.time.serveraction(id,act)
	if customcoloursel[id].inmenu then
		customcolourmenu(id,"hide")
	end
	if act == 3 then
		menu(id,"Time Display Config,Colour,Position,Time Style,Date Style,Time Zone,,Toggle Display |"..colourcheck(id))
	end
end

addhook("menu","pikachu.time.menu")
function pikachu.time.menu(id,tit,sel)
	if string.sub(tit,1,25) == "Time Display Colour Page " then
		local page = tonumber(string.sub(tit,26))
		local pages = math.ceil(#colourtable/6)
		if sel >= 1 and sel <= 6 then
			local prev = page - 1
			local pr6 = prev * 6
			local rsel = pr6 + sel
			if coloursel[id] ~= rsel then
				if customcoloursel[id].enabled then
					customcoloursel[id].enabled = false
					msg2(id,"\169000255000Change successful, now using preset colour!")
				else
					msg2(id,"\169000255000Change successful!")
				end
				coloursel[id] = rsel
			else
				if customcoloursel[id].enabled then
					customcoloursel[id].enabled = false
					msg2(id,"\169000255000Change successful, now using preset colour!")
				else
					msg2(id,"\169255000000You are currently using this colour!")
					colourmenu(id,page)
				end
			end
		elseif sel == 8 then
			if page == 1 then
				if not customcoloursel[id].enabled then
					customcoloursel[id].enabled = true
					msg2(id,"\169000255000Change successful, now using custom colour!")
				end
				if not customcoloursel[id].inmenu then
					customcolourmenu(id,"show")
				end
			else
				colourmenu(id,page-1)
			end
		elseif sel == 9 then
			if page == pages then
				if not customcoloursel[id].enabled then
					customcoloursel[id].enabled = true
					msg2(id,"\169000255000Change successful, now using custom colour!")
				end
				if not customcoloursel[id].inmenu then
					customcolourmenu(id,"show")
				end
			else
				colourmenu(id,page+1)
			end
		end
	elseif string.sub(tit,1,27) == "Time Display Position Page " then
		local page = tonumber(string.sub(tit,28))
		local pages = math.ceil(#postable/6)
		if sel >= 1 and sel <= 6 then
			local prev = page - 1
			local pr6 = prev * 6
			local rsel = pr6 + sel
			if possel[id] ~= rsel then
				possel[id] = rsel
				msg2(id,"\169000255000Change successful!")
			else
				msg2(id,"\169255000000You are currently using this position setting!")
				posmenu(id,page)
			end
		elseif sel == 8 then
			if page == 1 then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				posmenu(id,page)
			else
				posmenu(id,page-1)
			end
		elseif sel == 9 then
			if page == pages then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				posmenu(id,page)
			else
				posmenu(id,page+1)
			end
		end
	elseif string.sub(tit,1,29) == "Time Display Time Style Page " then
		local page = tonumber(string.sub(tit,30))
		local pages = math.ceil(#styletable.time/6)
		if sel >= 1 and sel <= 6 then
			local prev = page - 1
			local pr6 = prev * 6
			local rsel = pr6 + sel
			if styletimesel[id] ~= rsel then
				styletimesel[id] = rsel
				msg2(id,"\169000255000Change successful!")
			else
				msg2(id,"\169255000000You are currently using this time style setting!")
				stylemenu(id,"time",page)
			end
		elseif sel == 8 then
			if page == 1 then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				stylemenu(id,"time",page)
			else
				stylemenu(id,"time",page-1)
			end
		elseif sel == 9 then
			if page == pages then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				stylemenu(id,"time",page)
			else
				stylemenu(id,"time",page+1)
			end
		end
	elseif string.sub(tit,1,29) == "Time Display Date Style Page " then
		local page = tonumber(string.sub(tit,30))
		local pages = math.ceil(#styletable.date/6)
		if sel >= 1 and sel <= 6 then
			local prev = page - 1
			local pr6 = prev * 6
			local rsel = pr6 + sel
			if styledatesel[id] ~= rsel then
				styledatesel[id] = rsel
				msg2(id,"\169000255000Change successful!")
			else
				msg2(id,"\169255000000You are currently using this date style setting!")
				stylemenu(id,"date",page)
			end
		elseif sel == 8 then
			if page == 1 then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				stylemenu(id,"date",page)
			else
				stylemenu(id,"date",page-1)
			end
		elseif sel == 9 then
			if page == pages then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				stylemenu(id,"date",page)
			else
				stylemenu(id,"date",page+1)
			end
		end
	elseif string.sub(tit,1,28) == "Time Display Time Zone Page " then
		local page = tonumber(string.sub(tit,29))
		local pages = math.ceil(#timezones/6)
		if sel >= 1 and sel <= 6 then
			local prev = page - 1
			local pr6 = prev * 6
			local rsel = pr6 + sel
			if timezonesel[id] ~= rsel then
				timezonesel[id] = rsel
				msg2(id,"\169000255000Change successful!")
			else
				msg2(id,"\169255000000You are currently using this date style setting!")
				timezonemenu(id,page)
			end
		elseif sel == 8 then
			if page == 1 then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				timezonemenu(id,page)
			else
				timezonemenu(id,page-1)
			end
		elseif sel == 9 then
			if page == pages then
				if colouron[id] then
					colouron[id] = false
					msg2(id,"\169255000000Time Display disabled!")
				else
					colouron[id] = true
					msg2(id,"\169000255000Time Display enabled!")
				end
				timezonemenu(id,page)
			else
				timezonemenu(id,page+1)
			end
		end
	elseif tit == "Time Display Config" then
		if sel == 1 then
			colourmenu(id,1)
		elseif sel == 2 then
			posmenu(id,1)
		elseif sel == 3 then
			stylemenu(id,"time",1)
		elseif sel == 4 then
			stylemenu(id,"date",1)
		elseif sel == 5 then
			timezonemenu(id,1)
		elseif sel == 7 then
			if colouron[id] then
				colouron[id] = false
				msg2(id,"\169255000000Time Display disabled!")
			else
				colouron[id] = true
				msg2(id,"\169000255000Time Display enabled!")
			end
			menu(id,"Time Display Config,Colour,Position,Time Style,Date Style,Time Zone,,Toggle Display |"..colourcheck(id))
		end
	end
end

addhook("attack","pikachu.time.attack")
function pikachu.time.attack(id)
	if customcoloursel[id].inmenu then
		reqcld(id,0)
	end
end

addhook("clientdata","pikachu.time.clientdata")
function pikachu.time.clientdata(id,mode,data1,data2)
	if mode == 0 then
		if customcoloursel[id].inmenu then
			-- R
			if data1 >= 192 and data1 <= 447 and data2 >= 217 and data2 <= 232 then
				customcoloursel[id].r = (data1 - 192)
			end
			-- G
			if data1 >= 192 and data1 <= 447 and data2 >= 245 and data2 <= 260 then
				customcoloursel[id].g = (data1 - 192)
			end
			-- B
			if data1 >= 192 and data1 <= 447 and data2 >= 273 and data2 <= 288 then
				customcoloursel[id].b = (data1 - 192)
			end
			-- Close
			if data1 >= 200 and data1 <= 440 and data2 >= 305 and data2 <= 330 then
				customcolourmenu(id,"hide")
			end
			updatecustomcolour(id)
		end
	end
end

if time_optimize then
	addhook("ms100","pikachu.time.alwaysms100")
else
	addhook("always","pikachu.time.alwaysms100")
end

function pikachu.time.alwaysms100()
	for _, i in ipairs(player(0,"table")) do
		if colouron[i] then
			local r2, r3, r4, r5 = possel[i], styletimesel[i], styledatesel[i], timezonesel[i]
			local t = os.time() + ((timezones[r5] - servertimezone) * 3600)
			local r
			if customcoloursel[i].enabled then
				r = string.format("%s%s%s",digits(customcoloursel[i].r,3,255),digits(customcoloursel[i].g,3,255),digits(customcoloursel[i].b,3,255))
			else
				r = colourtable[coloursel[i]].num
			end
			parse("hudtxt2 "..i.." 48 \""..os.date("\169"..r.."Time ("..timezoneformat(r5).."): "..styletable.time[r3].syntax.."",t).."\" "..postable[r2].x.." "..postable[r2].y.." "..postable[r2].orientation)
			parse("hudtxt2 "..i.." 49 \""..os.date("\169"..r.."Date ("..timezoneformat(r5).."): "..styletable.date[r4].syntax.."",t).."\" "..postable[r2].x.." "..(postable[r2].y+16).." "..postable[r2].orientation)
		else
			parse("hudtxt2 "..i.." 48")
			parse("hudtxt2 "..i.." 49")
		end
	end
end